<script setup lang="ts">
import { ref, watch } from 'vue'
import { useRoute } from 'vue-router'

const props = defineProps({
  options: {
    type: Object,
    required: true,
  },
  default: {
    type: String,
    required: false,
    default: null,
  },
  tabindex: {
    type: Number,
    required: false,
    default: 0,
  },
  modelValue: {
    type: String,
    required: false,
  },
})

const emit = defineEmits(['update:modelValue'])

const route = useRoute()
const selected = ref(props.options[props.modelValue ?? 'name']);
watch(() => route.query.c, () => {
  selected.value = String(props.options[String(route.query.c)] ?? props.options[String(props.modelValue)]);
});

const open = ref(false);

function updateValue(value: string) {
  emit('update:modelValue', value)
}
</script>

<template>
  <div class="custom-select" :tabindex="tabindex" @blur="open = false">
    <div class="selected" :class="{ open: open }" @click="open = !open">
      {{ selected }}
    </div>
    <div class="items" :class="{ selectHide: !open }">
      <div
        v-for="(option, key, i) of options"
        :key="i"
        @click="
          selected = option;
          open = false;
          updateValue(key)
        "
      >
        {{ option }}
      </div>
    </div>
  </div>
</template>

<style scoped>
.custom-select {
    position: relative;
    width:25%;
    text-align: left;
    outline: none;
    height: 56px;
    line-height: 47px;
    box-sizing: border-box;
    align-self: center;
  }

  .custom-select .selected {
    padding-left: 1rem;
    cursor: pointer;
    user-select: none;
    align-self: center;
    justify-self: center;
    height: 56px;
    display: flex;
    justify-content: space-between;
    align-items: center;
    flex-direction: row;
    flex-wrap: nowrap;
    align-content: center;
    border-left:1px solid;
    border-right:1px solid;
  }

  .custom-select .selected.open {
    border-radius: 0 0 0 0;
  }

  .custom-select .selected:after {
    position: absolute;
    content: "";
    right: 1em;
    width: 0;
    height: 0;
    border: 5px solid transparent;
    border-color: #A9B1BD transparent transparent transparent;
  }

  .custom-select .items {
    border-radius: 0px 0px 12px 12px;
    overflow: hidden;
    position: absolute;
    color: var(--color-text);
    background: var(--color-background);
    border:1px solid #A9B1BD;
    left: 0;
    right: 0;
    z-index: 1;
  }

  .custom-select .items div {
    padding-left: 1rem;
    cursor: pointer;
    user-select: none;
  }
.custom-select .items div:not(last-child){
    border-bottom:1px solid #A9B1BD;

}
  .custom-select .items div:hover {
    background-color: #11B0C8;
    color: #fff;
  }

  .selectHide {
    display: none;
  }
</style>
